<?php

/**
 * @var string $payment_link
 * @var string $return_url
 * @var string $method
 * @var int    $order_id
 * @var string $profile_id
 * @var string $imoje_blik_oneclick
 * @var array  $active_profile
 */

$accept_tip_1 = __('Now accept your payment in bank application.', 'imoje');
$accept_tip_2 = __('You will be informed via e-mail about it end status, or you can check your payment status later.', 'imoje');

$failure_tip_1 = __('Unable to complete your payment request.', 'imoje');
$failure_tip_2 = __('Try again later or contact with shop staff.', 'imoje');

?>

<style>

    .loading_gif {
        display: block;
        margin-left: auto;
        margin-right: auto;
    }

    #blik_code {
        width: 230px;
    }

    #blik_submit {
        margin-bottom: 3px;
    }


    .blik-alias, .alias-deactivate {
        margin-right: 5px;
        margin-bottom: 5px;
    }

    .alias-deactivate {
        font-weight: 600;
        text-transform: uppercase
    }

    .modal_blik {
        display: none;
        position: fixed;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        z-index: 50000;
        background: rgba(0, 0, 0, .5)
    }

    .modal_blik-content {
        background: #fbfbfb none;
        border: 1px solid #d6d4d4;
        border-radius: 4px;
        transform: translate(-50%, -50%);
        position: absolute;
        top: 50%;
        left: 50%;
        color: black;
        padding: 20px;
        text-align: center;
    }

    #modal_blik_code-content {
        max-width: 274px;
    }

    #insert_blik_code-text:after {
        float: right;
        content: "\25bc";
    }

    #insert_blik_code-text.is-active:after {
        content: "\25b2";
    }

    .d--none {
        display: none;
    }

    .mt {
        margin-top: 1.5rem;
    }

    #content_blik_oneclick {
        margin-bottom: 10px;
    }
</style>

<section class="clearfix" style="display:block">

    <h3 id="text-tip" class="d--none"></h3>
    <div id="content_blik_code">

		<?php if(isset($active_profile) && $active_profile) { ?>
            <div id="content_blik_oneclick">
                <h2>
					<?= __('Debit profile', 'imoje') ?>
                </h2>
                <div class="div_profile">
					<?php foreach($active_profile['aliasList'] as $alias) { ?>
                        <div data-blik-key="<?= $alias['key'] ?>"
                             data-blik-name="<?= $alias['label'] ?>" class="blik-alias-div">
                            <button class="btn btn-primary blik-alias">
								<?= $alias['label'] ?>
                            </button>
                            <button class="btn btn-danger alias-deactivate">
								<?= __('Deactivate', 'imoje') ?>
                            </button>
                        </div>
					<?php } ?>
                </div>
                <br/>
                <hr/>
            </div>
		<?php } ?>

        <h2 id="insert_blik_code-text"><?= __('Insert BLIK code', 'imoje') ?></h2>

        <div class="content_insert_code d--none">

            <label for="blik_code" style="margin-top:100px">
            </label>
            <input placeholder="<?= __('BLIK code...', 'imoje') ?>" id="blik_code" class="form-control" type="text"
                   name="blik_code"
                   required autocomplete="off" maxlength="6">
            <button id="blik_submit" class="action primary disabled" disabled type="submit">
                <span><?= __('Pay', 'imoje') ?></span>
            </button>
			<?php if(isset($imoje_blik_oneclick) && $imoje_blik_oneclick) { ?>
                <div class="remember_code-content">
                    <label for="remember_code-checkbox">
                                    <span>
                                        <input type="checkbox" class="checkbox" id="remember_code-checkbox"
                                               name="remember_code-checkbox">
                                    </span>
						<?= __('I want to remember this shop', 'imoje') ?>
                    </label>
                </div>
			<?php } ?>
        </div>
        <br/>
    </div>

    <div class="modal_blik" id="modal_processing">
        <div class="modal_blik-content" id="modal_processing-content">
            <img class="loading_gif" src="<?= WOOCOMMERCE_IMOJE_PLUGIN_URL . 'resources/images/loading.gif' ?>"
                 alt="<?= __('Loading', 'imoje') ?>"/>
            <br/>
            <span id="modal_processing-tip">
                </span>
        </div>
    </div>

    <div class="modal_blik" id="modal_blik_code">
        <div class="modal_blik-content" id="modal_blik_code-content">
            <p id="proceed_payment_code"></p>
            <label for="blik_code_modal" class="d--none">
            </label>
            <input placeholder="<?= __('BLIK code...', 'imoje') ?>"
                   id="blik_code_modal"
                   class="form-control"
                   type="text"
                   name="blik_code"
                   required autocomplete="off"
                   maxlength="6">
            <div class="mt">
                <button id="blik_submit_modal" class="btn btn-primary btn-submit-code disabled blik_submit" disabled>
					<?= __('Pay', 'imoje') ?>
                </button>
                <button class="btn btn-secondary btn-modal-close">
					<?= __('Close', 'imoje') ?>
                </button>
            </div>
        </div>
    </div>

    <div class="modal_blik" id="modal_blik_alias_deactivate-modal">
        <div class="modal_blik-content" id="modal_blik_alias_deactivate-modal-content">
            <h2 class="h3">
				<?= __('Deactivate profile', 'imoje') ?>
            </h2>
            <label for="blik_code" class="">
            </label>
            <p>
				<?= __('Are you sure that you want deactivate profile ', 'imoje') ?>
                <span id="deactivate_profile_name-text"></span>?
            </p>
            <div class="mt-5">
                <button id="deactivate_profile_accept-btn" class="btn btn-primary">
					<?= __('Deactivate', 'imoje') ?>
                </button>
                <button class="btn btn-secondary btn-modal-close">
					<?= __('Close', 'imoje') ?>
                </button>
            </div>
        </div>
    </div>
</section>

<script type="text/javascript">

    document.addEventListener("DOMContentLoaded", function (event) {

        (function () {

            var $blik_code = jQuery("#blik_code"),
                $blik_code_modal = jQuery('#blik_code_modal'),
                $blik_submit = jQuery('#blik_submit'),
                $modal_processing = jQuery('#modal_processing'),
                $insert_blik_code_text = jQuery('#insert_blik_code-text'),
                $modal_processing_tip = jQuery('#modal_processing-tip'),
                $text_tip = jQuery('#text-tip'),
                timeout_append_result_text = '',
                ms_append_result_text = 60000,
                dont_processing = false,
                dont_processing_timeout = null,
                temp_new_param_alias = null,
                $modal_blik_code = jQuery('#modal_blik_code'),
                $content_blik_code = jQuery('#content_blik_code'),
                $content_blik_oneclick = jQuery('#content_blik_oneclick'),
                $proceed_payment_code_text = jQuery('#proceed_payment_code'),
                $btn_modal_close = jQuery('.btn-modal-close'),
                $modal_blik = jQuery('.modal_blik'),
                $blik_submit_modal = jQuery('#blik_submit_modal'),
                ms_blik_submit = 90000,
                $remember_code_checkbox = jQuery('#remember_code-checkbox'),
                $deactivate_profile_accept_button = jQuery('#deactivate_profile_accept-btn'),
                $deactivate_profile_name_text = jQuery('#deactivate_profile_name-text'),
                $alias_deactivate_button = jQuery('.alias-deactivate'),
                $modal_blik_alias_deactivate_modal = jQuery('#modal_blik_alias_deactivate-modal'),
                temp_this = null,
                profile_id = '',
                $blik_profile = jQuery('.blik-alias'),
                is_submitted = false;

            // region debit profile
            $blik_profile.on("click", function () {

                dont_processing_timeout = setTimeout(
                    function () {
                        dont_processing = true
                    }, ms_blik_submit);

                var parent = jQuery(this).parent(),
                    key = parent.data("blik-key")
                        ? parent.data("blik-key")
                        : null;

                process_form({
                        action: 'imoje_debit_alias',
                        profile_id: profile_id,
                        blik_key: key,
                    },
                    '',
                    function (response) {

                        if (response.success && response.data.transaction.id) {
                            check_payment(response.data.transaction.id);
                            return;
                        }

                        $modal_processing.hide();
                        append_result_text('<?= __('Could not debit profile. Try again later or contact with shop staff.', 'imoje') ?>', 'red');
                    }
                );

            });
            // endregion

            // region deactivate profile
            $alias_deactivate_button.on('click', function () {

                $deactivate_profile_name_text.html(jQuery(this).parent().data("blik-name"))

                temp_this = jQuery(this);
                $modal_blik_alias_deactivate_modal.show();
            });

            $deactivate_profile_accept_button.on('click', function () {

                $modal_blik_alias_deactivate_modal.hide();

                if (!temp_this) {
                    return;
                }

                var blik_key = temp_this.parent().data('blik-key');

                process_form({
                        action: 'imoje_deactivate_alias',
                        profile_id: profile_id,
                        blik_key: blik_key,
                    },
                    '<?= __('Please wait, deactivation is in progress', 'imoje') ?>',
                    function (response) {

                        $modal_processing.hide();

                        if (response.success) {

                            jQuery('div[data-blik-key=' + blik_key + ']').remove();

                            append_result_text("<?= __('Successfully deactivated profile', 'imoje') ?>" + " " + temp_this.parent().data('blik-name'), 'green');

                            if (jQuery('.blik-alias-div').length === 0) {
                                toggle_content_insert_code();
                                jQuery('div[data-profile-id=' + profile_id + ']').remove();
                                $content_blik_oneclick.remove();
                                profile_id = '';
                            }
                            return;
                        }

                        append_result_text('<?= __('Could not deactivate profile. Try again later or contact with shop staff.', 'imoje') ?>', 'red')
                    })
            })

            // endregion

            function toggle_content_insert_code() {
                $insert_blik_code_text.toggleClass('is-active').next(".content_insert_code").stop().slideToggle(500);
            }

			<?php if(!$active_profile) { ?>
            toggle_content_insert_code();
			<?php } ?>

			<?php if($profile_id) { ?>
            profile_id = "<?=$profile_id ?>";
			<?php } ?>

            $insert_blik_code_text.on('click', function () {
                toggle_content_insert_code();
            });

            if (!is_submitted) {

                $blik_code.on('input', function () {
                    if ($blik_code.val().length === 6) {
                        $blik_submit.removeClass('disabled');
                        $blik_submit.removeAttr("disabled");
                    } else {
                        disable_blik_submit();
                    }
                });

                $blik_code_modal.on('input', function () {
                    if ($blik_code_modal.val().length === 6) {
                        $blik_submit_modal.removeClass('disabled').removeAttr("disabled");
                    } else {
                        disable_blik_submit();
                    }
                });
            }

            $btn_modal_close.on('click', function () {
                    $modal_blik.hide();
                }
            )

            function blik_submit(data) {

                data.action = 'imoje_create_transaction';
                data.order_id = <?= $order_id ?>;

                disable_blik_submit();
                is_submitted = true;
                $modal_blik.hide();
                clear_dont_processing_timeout()

                dont_processing_timeout = setTimeout(
                    function () {
                        dont_processing = true
                    }, ms_blik_submit);

                process_form(data);
            }

            $blik_submit.on('click', function () {

                var data = {
                    code: $blik_code.val(),
                }

                if ($remember_code_checkbox.is(":checked")) {
                    data.remember_blik_code = 1;

                    if (profile_id) {
                        data.profile_id = profile_id
                    }
                }

                blik_submit(data);
            });

            $blik_submit_modal.on('click', function () {

                var data = {
                    code: $blik_code_modal.val(),
                }

                if (temp_new_param_alias) {
                    data.remember_blik_code = 1
                }

                blik_submit(data);
            });

            function disable_blik_submit() {
                $blik_submit.addClass('disabled');
                $blik_submit.attr("disabled", true);
            }

            // region show modal processing
            function show_modal_processing(text) {
                $modal_processing_tip.html(text);
                $modal_processing.show();
            }

            // endregion

            function clear_inputs() {
                $blik_code.val('');
                $blik_code_modal.val('');
            }

            function append_result_text(text, color) {

                clearTimeout(timeout_append_result_text);

                $text_tip.show();
                $text_tip.html(text).css('color', color);
                timeout_append_result_text = setTimeout(function () {
                    $text_tip.hide();
                }, ms_append_result_text)
            }

            function clear_dont_processing_timeout() {
                clearTimeout(dont_processing_timeout);
                dont_processing = false;
            }

            function check_payment(transactionId) {

                jQuery.ajax({
                    data: {
                        action: 'imoje_check_transaction',
                        method: '<?= $method ?>',
                        transaction_uuid: transactionId,
                    },
                    method: "POST",
                    url: "<?= $payment_link ?>",
                })
                    .then(function (response) { // done
                        if (dont_processing) {
                            $modal_processing.hide();
                            append_result_text('<?= __('Response timed out. Try again.', 'imoje') ?>', 'red');
                            clear_dont_processing_timeout();
                            return;
                        }

                        if (!response.success) {

                            $modal_processing.hide();

                            append_result_text('<?= __('Something went wrong. Please contact with shop staff', 'imoje') ?>', 'red');
                            clear_dont_processing_timeout();
                            return;
                        }

                        if (response.data.error) {

                            $modal_processing.hide();

                            clear_dont_processing_timeout();

                            if (response.data.code) {

                                $proceed_payment_code_text.html(response.data.error);

                                if (response.data.newParamAlias) {
                                    temp_new_param_alias = true;
                                }

                                $modal_blik_code.show();
                                return;
                            }

                            append_result_text(response.data.error, 'red');
                            return;
                        }

                        if (response.data.transaction.status === 'pending') { // state inny niz pending

                            if (dont_processing) {
                                $modal_processing.hide();
                                append_result_text('<?= __('Response timed out. Try again.', 'imoje') ?>', 'red');
                                clear_dont_processing_timeout();
                                return;
                            }

                            setTimeout(function () {
                                check_payment(transactionId)
                            }, 1000);

                            return;
                        }

                        clear_dont_processing_timeout();

                        if (response.data.transaction.status === 'settled') {
                            window.location.href = '<?= $return_url ?>'
                            return;
                        }

                        $modal_processing.hide();
                        $content_blik_code.html('<?= $failure_tip_1 . '<br/><br/>' . $failure_tip_2 ?>');

                    }, function () { // fail
                    });
            }

            // region process form
            function process_form(data, modalTipText = '', func_at_done = null, func_at_always = null) {

                data.order_id = <?= $order_id ?>;
                data.method = '<?= $method ?>';
                document.activeElement.blur();

                jQuery.ajax({
                    method: "POST",
                    url: "<?= $payment_link ?>",
                    data: data,
                    beforeSend: function () {

                        $text_tip.hide();
                        clear_inputs();
                        show_modal_processing(modalTipText
                            ? modalTipText
                            : ' <?= __('Now accept payment in your bank application', 'imoje') ?>');
                    }
                })
                    .done(function (response) {

                        if (!response.success) {
                            $modal_processing.hide();
                            append_result_text('<?= __('Something went wrong. Please contact with shop staff', 'imoje') ?>', 'red');
                            return;
                        }

                        if (response.data && response.data.error) {

                            $modal_processing.hide();

                            clear_dont_processing_timeout();

                            if (response.data.code) {

                                jQuery('#proceed_payment_code').html(response.data.error);

                                if (response.data.newParamAlias) {
                                    temp_new_param_alias = true;
                                }

                                $modal_blik_code.show();
                                return;
                            }

                            append_result_text(response.data.error, 'red');
                            return;
                        }

                        if (func_at_done) {
                            func_at_done(response);
                            return;
                        }

                        if (response.data.transaction.status === 'settled') {
                            window.location.href = '<?= $return_url ?>'
                            return;
                        }

                        if (response.data.transaction.status === 'rejected') {
                            $content_blik_code.html('<?= $failure_tip_1 . ' <br/><br/>' . $failure_tip_2 ?>');
                            return;
                        }

                        if (response.data.transaction.id) {
                            check_payment(response.data.transaction.id);
                            return;
                        }

                        $modal_processing.hide();
                        append_result_text('<?='Something went wrong. Please contact with shop staff', 'imoje' ?>', 'red');
                    })
                    .fail(function () {
                        $modal_processing.hide();
                        append_result_text('<?='Something went wrong. Please contact with shop staff', 'imoje' ?>', 'red');
                    })
                    .always(function (response) {
                        if (func_at_always) {
                            func_at_always(response);
                        }
                    });
            }

            // endregion
        })()
    });
</script>
