<?php

/**
 * @var array  $payment_method_list
 * @var string $payment_link
 */

?>

<style>
	.box-pm {
		display:-webkit-box;
		display:-ms-flexbox;
		display:flex;
		-ms-flex-wrap:wrap;
		flex-wrap:wrap;
		-webkit-box-pack:start;
		-ms-flex-pack:start;
	}

	.title {
		margin-bottom:30px;
	}

	.pm {
		margin:0 5px;
	}

	.pm-content {
		position:relative;
		margin-bottom:1.563rem;
		height:165px;
		width:185px;
		background:#fff;
		box-shadow:2px 2px 8px 0 rgb(0 0 0 / 20%);
		border:1px solid transparent;
	}

	.pm-content:hover {
		border-color:green
	}

	.pm-logo {

		max-height:50%;
		max-width:65%;
		position:absolute;
		top:0;
		bottom:0;
		left:0;
		right:0;
		margin:auto;
	}

	.pm-description {
		padding:4px;
		z-index:2;
		text-align:center;
		transition:bottom .3s;
		color:black;
	}

	.pm-link:hover {
		text-decoration:none;

	}

	.hidden {
		display:none;
	}

	.pbl_loading-content {
		background:#fbfbfb none;
		border:1px solid #d6d4d4;
		border-radius:4px;
		transform:translate(-50%, -50%);
		position:absolute;
		top:50%;
		left:50%;
		color:black;
		padding:20px;
	}

	#pbl_loading {
		position:fixed;
		top:0;
		left:0;
		right:0;
		bottom:0;
		z-index:50000;
		background:rgba(0, 0, 0, .5)
	}

	.pbl_is_not_online {
		filter:grayscale(100%);
		pointer-events:none;
		text-decoration:none !important;
	}
</style>

<section style="display:block">

	<h2 class="h3 text-uppercase title">
		<?= __('Choose payment channel', 'imoje') ?>
	</h2>
	<div class="box-pm row">
		<div id="pbl_loading" class="hidden">
			<div class="pbl_loading-content">
				<?= __('Please wait, you will be redirected to next step.', 'imoje') ?>
			</div>
		</div>

		<?php foreach($payment_method_list as $payment_method) {

			$href = '#';
			$aClass = 'pm-link pbl_is_not_online';
			$title = '';

			if($payment_method['isAvailable']) {
				$href = $payment_link . '&pm=' . $payment_method['paymentMethod'] . '&pmc=' . $payment_method['paymentMethodCode'];
				$title = __('This method is not available at this moment');
				$aClass = 'pm-link';
			}

			?>

			<div class="pm" title="<?= $title ?>">
				<a class="<?= $aClass ?>"
				   href="<?= $href ?>">
					<div class="pm-content">

						<?php if($payment_method['logo']) { ?>
							<img class="pm-logo" src="<?= $payment_method['logo'] ?>"
							     alt="<?= $payment_method['description'] ?>">
						<?php } ?>
						<div class="pm-description">
							<p>
								<?= $payment_method['description'] ?>
							</p>
						</div>
					</div>
				</a>
			</div>
		<?php } ?>
	</div>
</section>

<script type="text/javascript">
	document.addEventListener("DOMContentLoaded", function (event) {
		jQuery('.pm-link').click(function () {
			if (jQuery(this).attr('href') !== '#') {
				jQuery('#pbl_loading').removeClass('hidden');
			}
		});
	})
</script>
